package com.zerohighdef.geoffrey;

import com.zerohighdef.geoffrey.Commands.*;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.logging.Logger;

public final class GeoffreyMC extends JavaPlugin {
    private String APIToken;
    private String baseURL;
    private static FileConfiguration config;
    private Logger log = Logger.getLogger( "Minecraft" );

    @Override
    public void onEnable() {
        // Plugin startup logic
        saveDefaultConfig();
        reloadConfig();

        if (isEnabled()) {
            APIToken = config.getString("geoffrey_api.key");
            baseURL = config.getString("geoffrey_api.base_url");
            FindCommand findCommand = new FindCommand(this);
            this.getCommand("geoffrey_find").setExecutor(findCommand);

            SellingCommand sellingCommand = new SellingCommand(this);
            this.getCommand("geoffrey_selling").setExecutor(sellingCommand);
            this.getCommand("geoffrey_selling_price").setExecutor(sellingCommand);

            AddLocationCommand addLocationCommand = new AddLocationCommand(this);
            this.getCommand("geoffrey_add_base").setExecutor(addLocationCommand);
            this.getCommand("geoffrey_add_shop").setExecutor(addLocationCommand);
            this.getCommand("geoffrey_add_town").setExecutor(addLocationCommand);
            this.getCommand("geoffrey_add_farm").setExecutor(addLocationCommand);
            this.getCommand("geoffrey_add_attraction").setExecutor(addLocationCommand);

            RegisterCommand registerCommand = new RegisterCommand(this);
            this.getCommand("geoffrey_register").setExecutor(registerCommand);

            AddItemCommand addItemCommand = new AddItemCommand(this);
            this.getCommand("geoffrey_add_item").setExecutor(addItemCommand);

            AddResidentCommand addResidentCommand = new AddResidentCommand(this);
            this.getCommand("geoffrey_add_resident").setExecutor(addResidentCommand);
        }

    }

    public void log(String message) {
        log.info( "[GeoffreyMC]: " + message );
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }

    @Override
    public void reloadConfig() {
        super.reloadConfig();
        config = Bukkit.getPluginManager().getPlugin("GeoffreyMC").getConfig();

    }

    public String getAPIToken() {
        return APIToken;
    }

    public String getBaseURL() {
        return baseURL;
    }
}
